; -------------------------------------------------------------------------------------------------------------------------
; I don't give a fuck about the licence, do what you want with the code, but crediting the original author is always nice 
; This is a program to extract configuration data embedded in papras / ursnif dlls. ---- This will work only with the M 
; variant, and it has to be unpacked first. ----->  voir
; Usage in command line : extract.exe <ursnif dll> 
; For more information about the way it works, see the readme file
;
; To contact me for suggestions or bug reports : Horgh[at]lavabit[dot]com
; -------------------------------------------------------------------------------------------------------------------------

.386 
.model flat,stdcall 
option casemap:none 

include 	aplib/depack.asm
include	windows.inc
include	kernel32.inc 
include	user32.inc 
include 	shell32.inc 
include 	masm32.inc 

includelib	kernel32.lib
includelib	user32.lib 
includelib 	shell32.lib
includelib 	masm32.lib

.data?

hFile				HANDLE ?	; handle on dumped dll
hFile2			HANDLE ?	; handle on config file written on disk
lpBuffer			db 1024 dup (?)	; buffer for the header
lpNumberOfBytesRead		LPVOID ?
lpNbBytesWritten 	dd ?
lpCmdArg 			db 128 dup (?)
BufOut			dd ?			; ptr to allocated memory with uncompressed dlls

.data 

Checksum2	dd 0D722AFCBh
config2		db "config",0
strpg			db "This program intend to extract configuration data from TrojanSpy.Win32Ursnif.gen!M dlls. Be aware that previous variants won't work (different implementation).",13,10
			db "Usage : extract.exe <unpacked ursnif dll>",13,10,0
str2			db "--------------------------------------------------------------------------------",13,10,0
failed			db "The extraction process failed. Verify that your exe meet all the requirements",13,10,0
success		db "Congrats ! The extraction process was successful :)",13,10,0
configdata		db "Configuration data extraction... OK !",13,10,0

.code

start:
	
	invoke GetCL, 1, addr lpCmdArg				; get commandline argument
	invoke StdOut, addr strpg
	invoke StdOut, addr str2
	call ExtractConfig
	test eax, eax
	jne failure
	
	invoke StdOut, addr success
	invoke ExitProcess,0
	
failure:
	invoke StdOut, addr failed
	invoke ExitProcess,0

ExtractConfig proc 

	push ebp
	mov ebp, esp
	sub esp, 0Ch

	; Check if file passed in commandline exists, and open a handle on it if true
	invoke CreateFile, addr lpCmdArg,GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	cmp eax, INVALID_HANDLE_VALUE
	jz SomethingWentWrong
	mov hFile, eax
	
	; read the first 1024 octets of the file, check if the file is an executable
	invoke ReadFile,hFile, addr lpBuffer, sizeof lpBuffer, addr lpNumberOfBytesRead, 0 
	mov ebx, offset lpBuffer
	mov ax, "ZM"
	cmp ax, word ptr [lpBuffer]
	jnz SomethingWentWrong
	
	; retieve ptr to dll structure
	mov     eax, [ebx+3Ch]  			; e_lfanew
	add     eax, ebx     				; PE Header RVA 
	movzx   ecx, word ptr [eax+6] 		; retrieve NumberOfSections
	movzx   edx, word ptr [eax+14h]		; retrieve SizeOfOptionalHeader
	imul    ecx, 28h
	add    ecx, eax    					; add ImageBase
	lea     esi, [edx+ecx+40h] 			; (ImageBase + (NumberOfSections * 28)) + SizeOfOptionalHeader + 40 = VA to dll structure
	add	esi, 14h					; ptr to struct 2

	; test if 'FJ' mark is present on the first word of the structure
LoadStructMark:	
	movzx	eax, word ptr [esi]
	test	ax, ax					 ; test if null, if not jump to cmp
	jnz	short TestIfMark	
	jmp	SomethingWentWrong			; if not, the structure was not found.

TestIfMark:	
	mov	ecx, 4A46h					
	cmp	ax, cx					
	jz	short MarkFound	
	jmp	SomethingWentWrong
	
	; if a correct structure was found, check if its 5th field is equal to the constant
MarkFound:
	mov eax, Checksum2
	cmp	[esi+0Ch], eax				; now compare constant in the struct and constant in the code
	jnz	 SomethingWentWrong

	; Allocate memory for reading compressed config data
	mov	eax, [esi+8]				; eax = config size
	inc	eax						; size + 1
	push	eax						; uBytes
	push    40h           				; uFlags
	call    LocalAlloc
	mov	edi, eax
	test	edi, edi					; test if memory successfully allocated
	jz	SomethingWentWrong

	; Read compressed config and allocate memory to uncompress it
	mov	eax, [esi+4]				; eax = config VA
	invoke SetFilePointer,hFile,eax,NULL,FILE_BEGIN				; put FilePointer onto configVA
	invoke ReadFile,hFile, edi, [esi+8], addr lpNumberOfBytesRead, 0 
	mov	eax, [esi+8]				; eax = config size
	inc	eax						; size + 1
	push	eax						; uBytes
	push    40h           				; uFlags
	call    LocalAlloc
	
	; uncompress config with aplib
	mov BufOut, eax
	push	eax						; mem allocated
	push edi						; compressed config
	call	aP_depack_asm
	cmp	eax, [esi+8]				; check if everything decrypted
	jnz SomethingWentWrong 
	
	; write config to disk
	invoke CreateFile, addr config2, GENERIC_WRITE, 0, NULL,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	cmp eax, INVALID_HANDLE_VALUE
	jz SomethingWentWrong
	mov hFile2, eax
	invoke WriteFile,hFile2, BufOut, [esi+8], addr lpNbBytesWritten,NULL
	invoke StdOut, addr configdata
	invoke CloseHandle,hFile2
	xor eax, eax
	leave
	ret

SomethingWentWrong:
	mov eax, 1
	leave
	ret	

ExtractConfig endp

end start
